# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['BotmanChallengeActionArgs', 'BotmanChallengeAction']

@pulumi.input_type
class BotmanChallengeActionArgs:
    def __init__(__self__, *,
                 challenge_action: pulumi.Input[str],
                 config_id: pulumi.Input[int]):
        """
        The set of arguments for constructing a BotmanChallengeAction resource.
        """
        pulumi.set(__self__, "challenge_action", challenge_action)
        pulumi.set(__self__, "config_id", config_id)

    @property
    @pulumi.getter(name="challengeAction")
    def challenge_action(self) -> pulumi.Input[str]:
        return pulumi.get(self, "challenge_action")

    @challenge_action.setter
    def challenge_action(self, value: pulumi.Input[str]):
        pulumi.set(self, "challenge_action", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)


@pulumi.input_type
class _BotmanChallengeActionState:
    def __init__(__self__, *,
                 action_id: Optional[pulumi.Input[str]] = None,
                 challenge_action: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering BotmanChallengeAction resources.
        """
        if action_id is not None:
            pulumi.set(__self__, "action_id", action_id)
        if challenge_action is not None:
            pulumi.set(__self__, "challenge_action", challenge_action)
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)

    @property
    @pulumi.getter(name="actionId")
    def action_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "action_id")

    @action_id.setter
    def action_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "action_id", value)

    @property
    @pulumi.getter(name="challengeAction")
    def challenge_action(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "challenge_action")

    @challenge_action.setter
    def challenge_action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "challenge_action", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)


class BotmanChallengeAction(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 challenge_action: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Create a BotmanChallengeAction resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BotmanChallengeActionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a BotmanChallengeAction resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param BotmanChallengeActionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BotmanChallengeActionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 challenge_action: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BotmanChallengeActionArgs.__new__(BotmanChallengeActionArgs)

            if challenge_action is None and not opts.urn:
                raise TypeError("Missing required property 'challenge_action'")
            __props__.__dict__["challenge_action"] = challenge_action
            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            __props__.__dict__["action_id"] = None
        super(BotmanChallengeAction, __self__).__init__(
            'akamai:index/botmanChallengeAction:BotmanChallengeAction',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            action_id: Optional[pulumi.Input[str]] = None,
            challenge_action: Optional[pulumi.Input[str]] = None,
            config_id: Optional[pulumi.Input[int]] = None) -> 'BotmanChallengeAction':
        """
        Get an existing BotmanChallengeAction resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BotmanChallengeActionState.__new__(_BotmanChallengeActionState)

        __props__.__dict__["action_id"] = action_id
        __props__.__dict__["challenge_action"] = challenge_action
        __props__.__dict__["config_id"] = config_id
        return BotmanChallengeAction(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="actionId")
    def action_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "action_id")

    @property
    @pulumi.getter(name="challengeAction")
    def challenge_action(self) -> pulumi.Output[str]:
        return pulumi.get(self, "challenge_action")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "config_id")

