# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['BotmanClientSideSecurityArgs', 'BotmanClientSideSecurity']

@pulumi.input_type
class BotmanClientSideSecurityArgs:
    def __init__(__self__, *,
                 client_side_security: pulumi.Input[str],
                 config_id: pulumi.Input[int]):
        """
        The set of arguments for constructing a BotmanClientSideSecurity resource.
        """
        pulumi.set(__self__, "client_side_security", client_side_security)
        pulumi.set(__self__, "config_id", config_id)

    @property
    @pulumi.getter(name="clientSideSecurity")
    def client_side_security(self) -> pulumi.Input[str]:
        return pulumi.get(self, "client_side_security")

    @client_side_security.setter
    def client_side_security(self, value: pulumi.Input[str]):
        pulumi.set(self, "client_side_security", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)


@pulumi.input_type
class _BotmanClientSideSecurityState:
    def __init__(__self__, *,
                 client_side_security: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering BotmanClientSideSecurity resources.
        """
        if client_side_security is not None:
            pulumi.set(__self__, "client_side_security", client_side_security)
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)

    @property
    @pulumi.getter(name="clientSideSecurity")
    def client_side_security(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "client_side_security")

    @client_side_security.setter
    def client_side_security(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "client_side_security", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)


class BotmanClientSideSecurity(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 client_side_security: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Create a BotmanClientSideSecurity resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BotmanClientSideSecurityArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a BotmanClientSideSecurity resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param BotmanClientSideSecurityArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BotmanClientSideSecurityArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 client_side_security: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BotmanClientSideSecurityArgs.__new__(BotmanClientSideSecurityArgs)

            if client_side_security is None and not opts.urn:
                raise TypeError("Missing required property 'client_side_security'")
            __props__.__dict__["client_side_security"] = client_side_security
            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
        super(BotmanClientSideSecurity, __self__).__init__(
            'akamai:index/botmanClientSideSecurity:BotmanClientSideSecurity',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            client_side_security: Optional[pulumi.Input[str]] = None,
            config_id: Optional[pulumi.Input[int]] = None) -> 'BotmanClientSideSecurity':
        """
        Get an existing BotmanClientSideSecurity resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BotmanClientSideSecurityState.__new__(_BotmanClientSideSecurityState)

        __props__.__dict__["client_side_security"] = client_side_security
        __props__.__dict__["config_id"] = config_id
        return BotmanClientSideSecurity(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clientSideSecurity")
    def client_side_security(self) -> pulumi.Output[str]:
        return pulumi.get(self, "client_side_security")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "config_id")

