# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['BotmanCustomBotCategoryArgs', 'BotmanCustomBotCategory']

@pulumi.input_type
class BotmanCustomBotCategoryArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 custom_bot_category: pulumi.Input[str]):
        """
        The set of arguments for constructing a BotmanCustomBotCategory resource.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "custom_bot_category", custom_bot_category)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="customBotCategory")
    def custom_bot_category(self) -> pulumi.Input[str]:
        return pulumi.get(self, "custom_bot_category")

    @custom_bot_category.setter
    def custom_bot_category(self, value: pulumi.Input[str]):
        pulumi.set(self, "custom_bot_category", value)


@pulumi.input_type
class _BotmanCustomBotCategoryState:
    def __init__(__self__, *,
                 category_id: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_bot_category: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BotmanCustomBotCategory resources.
        """
        if category_id is not None:
            pulumi.set(__self__, "category_id", category_id)
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if custom_bot_category is not None:
            pulumi.set(__self__, "custom_bot_category", custom_bot_category)

    @property
    @pulumi.getter(name="categoryId")
    def category_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "category_id")

    @category_id.setter
    def category_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "category_id", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="customBotCategory")
    def custom_bot_category(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "custom_bot_category")

    @custom_bot_category.setter
    def custom_bot_category(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "custom_bot_category", value)


class BotmanCustomBotCategory(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_bot_category: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a BotmanCustomBotCategory resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BotmanCustomBotCategoryArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a BotmanCustomBotCategory resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param BotmanCustomBotCategoryArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BotmanCustomBotCategoryArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_bot_category: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BotmanCustomBotCategoryArgs.__new__(BotmanCustomBotCategoryArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if custom_bot_category is None and not opts.urn:
                raise TypeError("Missing required property 'custom_bot_category'")
            __props__.__dict__["custom_bot_category"] = custom_bot_category
            __props__.__dict__["category_id"] = None
        super(BotmanCustomBotCategory, __self__).__init__(
            'akamai:index/botmanCustomBotCategory:BotmanCustomBotCategory',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            category_id: Optional[pulumi.Input[str]] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            custom_bot_category: Optional[pulumi.Input[str]] = None) -> 'BotmanCustomBotCategory':
        """
        Get an existing BotmanCustomBotCategory resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BotmanCustomBotCategoryState.__new__(_BotmanCustomBotCategoryState)

        __props__.__dict__["category_id"] = category_id
        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["custom_bot_category"] = custom_bot_category
        return BotmanCustomBotCategory(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="categoryId")
    def category_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "category_id")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="customBotCategory")
    def custom_bot_category(self) -> pulumi.Output[str]:
        return pulumi.get(self, "custom_bot_category")

