# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['BotmanCustomDefinedBotArgs', 'BotmanCustomDefinedBot']

@pulumi.input_type
class BotmanCustomDefinedBotArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 custom_defined_bot: pulumi.Input[str]):
        """
        The set of arguments for constructing a BotmanCustomDefinedBot resource.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "custom_defined_bot", custom_defined_bot)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="customDefinedBot")
    def custom_defined_bot(self) -> pulumi.Input[str]:
        return pulumi.get(self, "custom_defined_bot")

    @custom_defined_bot.setter
    def custom_defined_bot(self, value: pulumi.Input[str]):
        pulumi.set(self, "custom_defined_bot", value)


@pulumi.input_type
class _BotmanCustomDefinedBotState:
    def __init__(__self__, *,
                 bot_id: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_defined_bot: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BotmanCustomDefinedBot resources.
        """
        if bot_id is not None:
            pulumi.set(__self__, "bot_id", bot_id)
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if custom_defined_bot is not None:
            pulumi.set(__self__, "custom_defined_bot", custom_defined_bot)

    @property
    @pulumi.getter(name="botId")
    def bot_id(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "bot_id")

    @bot_id.setter
    def bot_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "bot_id", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="customDefinedBot")
    def custom_defined_bot(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "custom_defined_bot")

    @custom_defined_bot.setter
    def custom_defined_bot(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "custom_defined_bot", value)


class BotmanCustomDefinedBot(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_defined_bot: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a BotmanCustomDefinedBot resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BotmanCustomDefinedBotArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a BotmanCustomDefinedBot resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param BotmanCustomDefinedBotArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BotmanCustomDefinedBotArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_defined_bot: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BotmanCustomDefinedBotArgs.__new__(BotmanCustomDefinedBotArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if custom_defined_bot is None and not opts.urn:
                raise TypeError("Missing required property 'custom_defined_bot'")
            __props__.__dict__["custom_defined_bot"] = custom_defined_bot
            __props__.__dict__["bot_id"] = None
        super(BotmanCustomDefinedBot, __self__).__init__(
            'akamai:index/botmanCustomDefinedBot:BotmanCustomDefinedBot',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            bot_id: Optional[pulumi.Input[str]] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            custom_defined_bot: Optional[pulumi.Input[str]] = None) -> 'BotmanCustomDefinedBot':
        """
        Get an existing BotmanCustomDefinedBot resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BotmanCustomDefinedBotState.__new__(_BotmanCustomDefinedBotState)

        __props__.__dict__["bot_id"] = bot_id
        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["custom_defined_bot"] = custom_defined_bot
        return BotmanCustomDefinedBot(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="botId")
    def bot_id(self) -> pulumi.Output[str]:
        return pulumi.get(self, "bot_id")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="customDefinedBot")
    def custom_defined_bot(self) -> pulumi.Output[str]:
        return pulumi.get(self, "custom_defined_bot")

