# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['BotmanTransactionalEndpointProtectionArgs', 'BotmanTransactionalEndpointProtection']

@pulumi.input_type
class BotmanTransactionalEndpointProtectionArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 transactional_endpoint_protection: pulumi.Input[str]):
        """
        The set of arguments for constructing a BotmanTransactionalEndpointProtection resource.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "transactional_endpoint_protection", transactional_endpoint_protection)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="transactionalEndpointProtection")
    def transactional_endpoint_protection(self) -> pulumi.Input[str]:
        return pulumi.get(self, "transactional_endpoint_protection")

    @transactional_endpoint_protection.setter
    def transactional_endpoint_protection(self, value: pulumi.Input[str]):
        pulumi.set(self, "transactional_endpoint_protection", value)


@pulumi.input_type
class _BotmanTransactionalEndpointProtectionState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[int]] = None,
                 transactional_endpoint_protection: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BotmanTransactionalEndpointProtection resources.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if transactional_endpoint_protection is not None:
            pulumi.set(__self__, "transactional_endpoint_protection", transactional_endpoint_protection)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="transactionalEndpointProtection")
    def transactional_endpoint_protection(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "transactional_endpoint_protection")

    @transactional_endpoint_protection.setter
    def transactional_endpoint_protection(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "transactional_endpoint_protection", value)


class BotmanTransactionalEndpointProtection(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 transactional_endpoint_protection: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a BotmanTransactionalEndpointProtection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BotmanTransactionalEndpointProtectionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a BotmanTransactionalEndpointProtection resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param BotmanTransactionalEndpointProtectionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BotmanTransactionalEndpointProtectionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 transactional_endpoint_protection: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BotmanTransactionalEndpointProtectionArgs.__new__(BotmanTransactionalEndpointProtectionArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if transactional_endpoint_protection is None and not opts.urn:
                raise TypeError("Missing required property 'transactional_endpoint_protection'")
            __props__.__dict__["transactional_endpoint_protection"] = transactional_endpoint_protection
        super(BotmanTransactionalEndpointProtection, __self__).__init__(
            'akamai:index/botmanTransactionalEndpointProtection:BotmanTransactionalEndpointProtection',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            transactional_endpoint_protection: Optional[pulumi.Input[str]] = None) -> 'BotmanTransactionalEndpointProtection':
        """
        Get an existing BotmanTransactionalEndpointProtection resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BotmanTransactionalEndpointProtectionState.__new__(_BotmanTransactionalEndpointProtectionState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["transactional_endpoint_protection"] = transactional_endpoint_protection
        return BotmanTransactionalEndpointProtection(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="transactionalEndpointProtection")
    def transactional_endpoint_protection(self) -> pulumi.Output[str]:
        return pulumi.get(self, "transactional_endpoint_protection")

