# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetCpsDeploymentsResult',
    'AwaitableGetCpsDeploymentsResult',
    'get_cps_deployments',
    'get_cps_deployments_output',
]

@pulumi.output_type
class GetCpsDeploymentsResult:
    """
    A collection of values returned by getCpsDeployments.
    """
    def __init__(__self__, auto_renewal_start_time=None, enrollment_id=None, expiry_date=None, id=None, production_certificate_ecdsa=None, production_certificate_rsa=None, staging_certificate_ecdsa=None, staging_certificate_rsa=None):
        if auto_renewal_start_time and not isinstance(auto_renewal_start_time, str):
            raise TypeError("Expected argument 'auto_renewal_start_time' to be a str")
        pulumi.set(__self__, "auto_renewal_start_time", auto_renewal_start_time)
        if enrollment_id and not isinstance(enrollment_id, int):
            raise TypeError("Expected argument 'enrollment_id' to be a int")
        pulumi.set(__self__, "enrollment_id", enrollment_id)
        if expiry_date and not isinstance(expiry_date, str):
            raise TypeError("Expected argument 'expiry_date' to be a str")
        pulumi.set(__self__, "expiry_date", expiry_date)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if production_certificate_ecdsa and not isinstance(production_certificate_ecdsa, str):
            raise TypeError("Expected argument 'production_certificate_ecdsa' to be a str")
        pulumi.set(__self__, "production_certificate_ecdsa", production_certificate_ecdsa)
        if production_certificate_rsa and not isinstance(production_certificate_rsa, str):
            raise TypeError("Expected argument 'production_certificate_rsa' to be a str")
        pulumi.set(__self__, "production_certificate_rsa", production_certificate_rsa)
        if staging_certificate_ecdsa and not isinstance(staging_certificate_ecdsa, str):
            raise TypeError("Expected argument 'staging_certificate_ecdsa' to be a str")
        pulumi.set(__self__, "staging_certificate_ecdsa", staging_certificate_ecdsa)
        if staging_certificate_rsa and not isinstance(staging_certificate_rsa, str):
            raise TypeError("Expected argument 'staging_certificate_rsa' to be a str")
        pulumi.set(__self__, "staging_certificate_rsa", staging_certificate_rsa)

    @property
    @pulumi.getter(name="autoRenewalStartTime")
    def auto_renewal_start_time(self) -> str:
        return pulumi.get(self, "auto_renewal_start_time")

    @property
    @pulumi.getter(name="enrollmentId")
    def enrollment_id(self) -> int:
        return pulumi.get(self, "enrollment_id")

    @property
    @pulumi.getter(name="expiryDate")
    def expiry_date(self) -> str:
        return pulumi.get(self, "expiry_date")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="productionCertificateEcdsa")
    def production_certificate_ecdsa(self) -> str:
        return pulumi.get(self, "production_certificate_ecdsa")

    @property
    @pulumi.getter(name="productionCertificateRsa")
    def production_certificate_rsa(self) -> str:
        return pulumi.get(self, "production_certificate_rsa")

    @property
    @pulumi.getter(name="stagingCertificateEcdsa")
    def staging_certificate_ecdsa(self) -> str:
        return pulumi.get(self, "staging_certificate_ecdsa")

    @property
    @pulumi.getter(name="stagingCertificateRsa")
    def staging_certificate_rsa(self) -> str:
        return pulumi.get(self, "staging_certificate_rsa")


class AwaitableGetCpsDeploymentsResult(GetCpsDeploymentsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCpsDeploymentsResult(
            auto_renewal_start_time=self.auto_renewal_start_time,
            enrollment_id=self.enrollment_id,
            expiry_date=self.expiry_date,
            id=self.id,
            production_certificate_ecdsa=self.production_certificate_ecdsa,
            production_certificate_rsa=self.production_certificate_rsa,
            staging_certificate_ecdsa=self.staging_certificate_ecdsa,
            staging_certificate_rsa=self.staging_certificate_rsa)


def get_cps_deployments(enrollment_id: Optional[int] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCpsDeploymentsResult:
    """
    Use this data source to access information about an existing resource.
    """
    __args__ = dict()
    __args__['enrollmentId'] = enrollment_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('akamai:index/getCpsDeployments:getCpsDeployments', __args__, opts=opts, typ=GetCpsDeploymentsResult).value

    return AwaitableGetCpsDeploymentsResult(
        auto_renewal_start_time=pulumi.get(__ret__, 'auto_renewal_start_time'),
        enrollment_id=pulumi.get(__ret__, 'enrollment_id'),
        expiry_date=pulumi.get(__ret__, 'expiry_date'),
        id=pulumi.get(__ret__, 'id'),
        production_certificate_ecdsa=pulumi.get(__ret__, 'production_certificate_ecdsa'),
        production_certificate_rsa=pulumi.get(__ret__, 'production_certificate_rsa'),
        staging_certificate_ecdsa=pulumi.get(__ret__, 'staging_certificate_ecdsa'),
        staging_certificate_rsa=pulumi.get(__ret__, 'staging_certificate_rsa'))
def get_cps_deployments_output(enrollment_id: Optional[pulumi.Input[int]] = None,
                               opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCpsDeploymentsResult]:
    """
    Use this data source to access information about an existing resource.
    """
    __args__ = dict()
    __args__['enrollmentId'] = enrollment_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('akamai:index/getCpsDeployments:getCpsDeployments', __args__, opts=opts, typ=GetCpsDeploymentsResult)
    return __ret__.apply(lambda __response__: GetCpsDeploymentsResult(
        auto_renewal_start_time=pulumi.get(__response__, 'auto_renewal_start_time'),
        enrollment_id=pulumi.get(__response__, 'enrollment_id'),
        expiry_date=pulumi.get(__response__, 'expiry_date'),
        id=pulumi.get(__response__, 'id'),
        production_certificate_ecdsa=pulumi.get(__response__, 'production_certificate_ecdsa'),
        production_certificate_rsa=pulumi.get(__response__, 'production_certificate_rsa'),
        staging_certificate_ecdsa=pulumi.get(__response__, 'staging_certificate_ecdsa'),
        staging_certificate_rsa=pulumi.get(__response__, 'staging_certificate_rsa')))
