# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['AppsecAdvancedSettingsAttackPayloadLoggingArgs', 'AppsecAdvancedSettingsAttackPayloadLogging']

@pulumi.input_type
class AppsecAdvancedSettingsAttackPayloadLoggingArgs:
    def __init__(__self__, *,
                 attack_payload_logging: pulumi.Input[str],
                 config_id: pulumi.Input[int],
                 security_policy_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a AppsecAdvancedSettingsAttackPayloadLogging resource.
        :param pulumi.Input[str] attack_payload_logging: Whether to enable, disable, or update attack payload logging settings
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        """
        pulumi.set(__self__, "attack_payload_logging", attack_payload_logging)
        pulumi.set(__self__, "config_id", config_id)
        if security_policy_id is not None:
            pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="attackPayloadLogging")
    def attack_payload_logging(self) -> pulumi.Input[str]:
        """
        Whether to enable, disable, or update attack payload logging settings
        """
        return pulumi.get(self, "attack_payload_logging")

    @attack_payload_logging.setter
    def attack_payload_logging(self, value: pulumi.Input[str]):
        pulumi.set(self, "attack_payload_logging", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[pulumi.Input[str]]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_policy_id", value)


@pulumi.input_type
class _AppsecAdvancedSettingsAttackPayloadLoggingState:
    def __init__(__self__, *,
                 attack_payload_logging: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AppsecAdvancedSettingsAttackPayloadLogging resources.
        :param pulumi.Input[str] attack_payload_logging: Whether to enable, disable, or update attack payload logging settings
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        """
        if attack_payload_logging is not None:
            pulumi.set(__self__, "attack_payload_logging", attack_payload_logging)
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if security_policy_id is not None:
            pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="attackPayloadLogging")
    def attack_payload_logging(self) -> Optional[pulumi.Input[str]]:
        """
        Whether to enable, disable, or update attack payload logging settings
        """
        return pulumi.get(self, "attack_payload_logging")

    @attack_payload_logging.setter
    def attack_payload_logging(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "attack_payload_logging", value)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[pulumi.Input[str]]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_policy_id", value)


class AppsecAdvancedSettingsAttackPayloadLogging(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 attack_payload_logging: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Create a AppsecAdvancedSettingsAttackPayloadLogging resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] attack_payload_logging: Whether to enable, disable, or update attack payload logging settings
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppsecAdvancedSettingsAttackPayloadLoggingArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a AppsecAdvancedSettingsAttackPayloadLogging resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param AppsecAdvancedSettingsAttackPayloadLoggingArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppsecAdvancedSettingsAttackPayloadLoggingArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 attack_payload_logging: Optional[pulumi.Input[str]] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppsecAdvancedSettingsAttackPayloadLoggingArgs.__new__(AppsecAdvancedSettingsAttackPayloadLoggingArgs)

            if attack_payload_logging is None and not opts.urn:
                raise TypeError("Missing required property 'attack_payload_logging'")
            __props__.__dict__["attack_payload_logging"] = attack_payload_logging
            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            __props__.__dict__["security_policy_id"] = security_policy_id
        super(AppsecAdvancedSettingsAttackPayloadLogging, __self__).__init__(
            'akamai:index/appsecAdvancedSettingsAttackPayloadLogging:AppsecAdvancedSettingsAttackPayloadLogging',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            attack_payload_logging: Optional[pulumi.Input[str]] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            security_policy_id: Optional[pulumi.Input[str]] = None) -> 'AppsecAdvancedSettingsAttackPayloadLogging':
        """
        Get an existing AppsecAdvancedSettingsAttackPayloadLogging resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] attack_payload_logging: Whether to enable, disable, or update attack payload logging settings
        :param pulumi.Input[int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[str] security_policy_id: Unique identifier of the security policy
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppsecAdvancedSettingsAttackPayloadLoggingState.__new__(_AppsecAdvancedSettingsAttackPayloadLoggingState)

        __props__.__dict__["attack_payload_logging"] = attack_payload_logging
        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["security_policy_id"] = security_policy_id
        return AppsecAdvancedSettingsAttackPayloadLogging(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="attackPayloadLogging")
    def attack_payload_logging(self) -> pulumi.Output[str]:
        """
        Whether to enable, disable, or update attack payload logging settings
        """
        return pulumi.get(self, "attack_payload_logging")

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Output[Optional[str]]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

